#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
using namespace std;

enum State {
    FieldStart,
    NormalField,
    QuotedField,
    Quote,
};

int main() {
    freopen("input.txt", "r", stdin);
    string line;
    vector<vector<string>> f;
    while (getline(cin, line)) {
        assert(!line.empty());
        f.emplace_back(vector<string>());
        f.back().emplace_back(string());
        State state = FieldStart;
        for (char c: line) {
            if (c == '"') {
                switch (state) {
                    case FieldStart:
                        state = QuotedField;
                        break;
                    case NormalField:
                        f.back().back().push_back(c);
                        break;
                    case QuotedField:
                        state = Quote;
                        break;
                    case Quote:
                        state = QuotedField;
                        f.back().back().push_back(c);
                        break;
                }
            } else if (c == ',') {
                switch (state) {
                case FieldStart:
                    state = FieldStart;
                    f.back().emplace_back(string());
                    break;
                case NormalField:
                    state = FieldStart;
                    f.back().emplace_back(string());
                    break;
                case QuotedField:
                    f.back().back().push_back(c);
                    break;
                case Quote:
                    state = FieldStart;
                    f.back().emplace_back(string());
                    break;
                }
            } else {
                switch (state) {
                case FieldStart:
                    state = NormalField;
                    f.back().back().push_back(c);
                    break;
                case NormalField:
                    f.back().back().push_back(c);
                    break;
                case QuotedField:
                    f.back().back().push_back(c);
                    break;
                case Quote:
                    assert(!"Odd quotes in the middle");
                    state = QuotedField;
                    f.back().back().push_back('"');
                    f.back().back().push_back(c);
                    break;
                }
            }
        }
        switch (state) {
        case FieldStart:
            break;
        case NormalField:
            break;
        case QuotedField:
            assert(!"linebreak in quotedfield");
            break;
        case Quote:
            break;
        }
    }
    vector<size_t> lens;
    for (const auto &q: f) {
        assert(!q.empty());
        if (lens.size() < q.size())
            lens.resize(q.size());
        for (size_t i = 0; i < q.size(); ++i)
            lens[i] = max(lens[i], q[i].length());
    }
    for (const auto &q: f) {
        for (size_t i = 0; i < lens.size(); ++i) {
            if (i) cout << "|";
            string s = (i < q.size()) ? q[i] : string();
            cout << s;
            cout << string(lens[i] - s.length(), ' ');
        }
        cout << '\n';
    }
}
