#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define E(x) cerr << #x << " = " << x << '\n'
using namespace std;

using flt = long double;
const flt eps = 1e-7;
const flt pi = acos(flt(-1));
using xy = array<flt, 2>;
const int N = 1024;
xy orig[N], tgt[N];
xy ora[N], tra[N];
xy oc, tc;

template<class T>
T sqr(T a) { return a * a; }
xy &operator+=(xy &a, const xy &b) {
    a[0] += b[0];
    a[1] += b[1];
    return a;
}
xy &operator-=(xy &a, const xy &b) {
    a[0] -= b[0];
    a[1] -= b[1];
    return a;
}
xy &operator/=(xy &a, flt b) {
    a[0] /= b;
    a[1] /= b;
    return a;
}
flt dist2(const xy &a, const xy &b) {
    return sqr(a[0] - b[0]) + sqr(a[1] - b[1]);
}
flt len2(const xy &a) {
    return sqr(a[0]) + sqr(a[1]);
}
flt ang(const xy &a) {
    return atan2(a[1], a[0]);
}

int main() {
    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> orig[i][0] >> orig[i][1];
        oc += orig[i];
    }
    oc /= n;
    for (int i = 0; i < n; ++i)
        orig[i] -= oc;
    for (int i = 0; i < n; ++i) {
        cin >> tgt[i][0] >> tgt[i][1];
        tc += tgt[i];
    }
    tc /= n;
    for (int i = 0; i < n; ++i)
        tgt[i] -= tc;
    for (int i = 0; i < n; ++i) {
        ora[i][1] = len2(orig[i]);
        ora[i][0] = ang(orig[i]);
        if (ora[i][1] < eps) ora[i][0] = 100;
        tra[i][1] = len2(tgt[i]);
        tra[i][0] = ang(tgt[i]);
        if (tra[i][1] < eps) tra[i][0] = 100;
        //cerr << i << ' ' << ora[i][1] << ' ' << ora[i][0] << " vs " << tra[i][1] << ' ' << tra[i][0] << '\n';
    }
    sort(ora, ora + n);
    sort(tra, tra + n);
    /*
        for (int i = 0; i < n; ++i) cerr << ora[i][0] << ':' << ora[i][1] << ' '; cerr << '\n';
        for (int i = 0; i < n; ++i) cerr << tra[i][0] << ':' << tra[i][1] << ' '; cerr << '\n';
    */
    int to = n;
    if (ora[n - 1][0] > 99) {
        assert(tra[n - 1][0] > 99);
        to = n - 1;
    } else {
        assert(!(tra[n - 1][0] > 99));
    }
    if (to > 0) {
        assert(ora[to-1][0] < 99);
        assert(tra[to-1][0] < 99);
    }
    flt ans = 100;
    for (int d = 0; d < to; ++d) {
        bool ok = true;
        flt mina = 100, maxa = -100;
        for (int i = 0; i < to; ++i) {
            int j = (i + d) % to;
            if (abs(ora[i][1] - tra[j][1]) > eps) {
                ok = false;
                break;
            }
            flt oda = i ? (ora[i][0] - ora[i - 1][0]) : (2 * pi + ora[0][0] - ora[to - 1][0]);
            flt tda = j ? (tra[j][0] - tra[j - 1][0]) : (2 * pi + tra[0][0] - tra[to - 1][0]);
            if (abs(oda - tda) > eps) {
                ok = false;
                break;
            }
            flt q = ora[i][0] - tra[j][0];
            if (q < 0) q += 2 * pi;
            mina = min(mina, q);
            maxa = max(maxa, q);
        }
        //cerr << d << ' ' << ok << '\n';
        if (!ok) continue;
        //cerr << "ma " << mina << ' ' << maxa << '\n';
        assert(mina - 1e-3 < maxa);
        assert(mina + 1e-3 > maxa);
        flt mida = (mina + maxa) / 2;
        if (mida > pi) mida = 2 * pi - mida;
        ans = min(ans, mida);
    }
    if (to > 0) {
        assert(ans < 100);
    } else {
        ans = 0;
    }
    cout << fixed << setprecision(9) << ans << '\n';
}
