#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <complex>
#include <bitset>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-9;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)

struct edge
{
	int to;
	int sign;
	int back;
	edge() {}
	edge(int to, int sign, int back) : to(to), sign(sign), back(back) {}
};

int n, m;
vector<vector<edge> > g;
int u[200010];
int ct[1000000];
int wc[1000000];
int any;
int sz;
bool megafail;

pii dfs(int v, int p)
{
	u[v] = 1;
	pii res(-1, -1);
	for (int i = 0; i < (int)g[v].size() && !megafail; i++)
	{
		if (p == i)
			continue;
		int to = g[v][i].to;
		if (u[to])
		{
			res = pii(to, sz);
			sz++;
		}
		else
		{
			auto tres = dfs(to, g[v][i].back);
			if(megafail)
				return pii(-1, -1);
			if (tres.first != -1)
			{
				if (res.first != -1)
				{
					megafail = true;
					return pii(-1, -1);
				}
				res = tres;
				if (g[v][i].sign == 0)
					wc[res.second]++;
				else if (g[v][i].sign == -1)
					ct[res.second] ^= 1;
			}
			else
			{
				any++;
			}
		}
	}
	if (res.first == v)
		res = pii(-1, -1);
	return res;
}

const int64 MOD = 111111111111111111;
int64 add(int64 a, int64 b)
{
	int64 res = a + b;
	if (res >= MOD)
		res -= MOD;
	return res;
}

int64 mul(int64 a, int64 b)
{
	int64 dd = (long double)a * b / MOD;
	int64 res = a * b - dd * MOD;
	while (res < 0)
		res += MOD;
	while (res >= MOD)
		res -= MOD;
	return res;
}

int64 binpow(int64 a, int64 p)
{
	int64 res = 1;
	while (p)
	{
		if (p & 1)
			res = mul(res, a);
		a = mul(a, a);
	}
}

void solve()
{
	cin >> n >> m;
	g.resize(n + 1);
	for (int i = 0; i < m && !megafail; i++)
	{
		int a, b, c;
		char t;
		cin >> a >> b >> t;
		if (t == '?')
			c = 0;
		else if (t == '+')
			c = 1;
		else
			c = -1;
		if (a == b)
		{
			if (c == 1)
				megafail = true;
		}
		else
		{
			int sa = g[a].size();
			int sb = g[b].size();
			g[a].push_back(edge(b, c, sb));
			g[b].push_back(edge(a, c, sa));
		}
	}
	for (int i = 1; i <= n && !megafail; i++)
	{
		if (!u[i])
			dfs(i, -1);
	}
	int ans = 0;
	for()
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
#endif

	solve();

	return 0;
}