#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <complex>
#include <bitset>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-9;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)

struct node
{
	int ass;
	int ctr;
	int s;
	int val() const
	{
		if (ass == -1)
			return s;
		else
			return ass * ctr;
	}
};

int q;
const int n = 200000;
node tre[1000010];

void pull(int tv, int tl, int tr)
{
	if (tl != tr)
	{
		tre[tv].s = tre[2 * tv].val() + tre[2 * tv + 1].val();
	}
}

void push(int tv, int tl, int tr)
{
	if (tre[tv].ass != -1)
	{
		if (tl != tr)
		{
			tre[2 * tv].ass = tre[tv].ass;
			tre[2 * tv + 1].ass = tre[tv].ass;
		}
		tre[tv].s = tre[tv].ass * tre[tv].ctr;
	}
}

void build(int tv, int tl, int tr)
{
	tre[tv].ctr = (tr - tl) + 1;
	tre[tv].ass = -1;
	tre[tv].s = 0;
	if (tl != tr)
	{
		int tm = (tl + tr) >> 1;
		build(2 * tv, tl, tm);
		build(2 * tv + 1, tm + 1, tr);
	}
}

void setv(int tv, int tl, int tr, int l, int r, int val)
{
	if (l > r)
		return;
	push(tv, tl, tr);
	if (l == tl && r == tr)
	{
		tre[tv].ass = val;
	}
	else
	{
		int tm = (tl + tr) >> 1;
		setv(2 * tv, tl, tm, l, min(r, tm), val);
		setv(2 * tv + 1, tm + 1, tr, max(tm + 1, l), r, val);
		pull(tv, tl, tr);
	}
}

int getv(int tv, int tl, int tr, int l, int r)
{
	if (l > r)
		return 0;
	push(tv, tl, tr);
	if (l == tl && r == tr)
	{
		return tre[tv].s; //check
	}
	else
	{
		int tm = (tl + tr) >> 1;
		return getv(2 * tv, tl, tm, l, min(r, tm)) +
			getv(2 * tv + 1, tm + 1, tr, max(tm + 1, l), r);
	}
}

int getcl(int pos, int val)
{
	int l = pos, r = n, res = pos;
	while (l <= r)
	{
		int mid = (l + r) >> 1;
		int s = getv(1, 0, n, pos, mid);
		int len = (mid - l + 1);
		int need = len * (val ^ 1);
		if (need != s)
		{
			res = mid;
			r = mid - 1;
		}
		else
			l = mid + 1;
	}
	return res;
}

void solve()
{
	build(1, 0, n);
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		string type;
		int ix;
		cin >> type >> ix;
		int val = 0;
		if (type == "add")
			val = 1;
		int pos = getcl(ix, val ^ 1);
		setv(1, 0, n, pos, pos, val);
		setv(1, 0, n, ix, pos - 1, val ^ 1);
		cout << getv(1, 0, n, 0, n) << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
#endif

	solve();

	return 0;
}