#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <utility>
#include <ctime>

using namespace std;

typedef long long int64;
typedef pair<int, int> pii;

const int MAXN = 200005;

struct edge
{
	int a, b;
	bool x, d;

	int get_to(int v)
	{
		return v == a ? b : a;
	}
};

int n, m;
vector <vector <int> > g;
bool o[MAXN];
vector <int> roots;
edge e[MAXN];
bool used[MAXN];
int h[MAXN], hq[MAXN];
bool val[MAXN];

void init()
{
	scanf ("%d%d", &n, &m);
	g.resize(n + 1);
	for (int i = 1; i <= m; i++)
	{
		char c;
		scanf ("%d%d %c", &e[i].a, &e[i].b, &c);
		e[i].x = (c == '-');
		e[i].d = (c != '?');
		g[e[i].a].push_back(i);
		g[e[i].b].push_back(i);
	}
}

void dfs(int v, int p)
{
	used[v] = true;
	for (int i = 0; i < (int)g[v].size(); i++)
	{
		int num = g[v][i];
		int to = e[num].get_to(v);
		if (to == p)
		{
			continue;
		}
		if (used[to])
		{
			continue;
		}
		h[to] = h[v] + 1;
		if (e[num].d)
		{
			hq[to] = hq[v];
			val[to] = val[v] ^ e[num].x;
		}
		else
		{
			hq[to] = num;
		}
		o[num] = true;
		dfs(to, v);
	}
}

void solve()
{
	init();
	for (int i = 1; i <= n; i++)
	{
		if (!used[i])
		{
			h[i] = 1;
			dfs(i, 0);
		}
	}
	int fr = m;
	for (int i = 1; i <= m; i++)
	{
		if (!o[i])
		{
			int a = e[i].a, b = e[i].b;
			if (e[i].d && hq[a] == hq[b] && e[i].x ^ val[a] ^ val[b] == false)
			{
				printf("0\n");
				return;
			}
			fr--;
		}
		else
		{
			if (e[i].d)
			{
				fr--;
			}
		}
	}
	const int64 MOD = 111111111111111111;
	int64 pw = 1;
	for (int i = 0;i < fr; i++)
	{
		pw <<= 1;
		if (pw >= MOD)
		{
			pw -= MOD;
		}
	}
	printf("%lld\n", pw);
}

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	srand(33);
	solve();

	return 0;
}