#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>
#include <sstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;
#define Sz(x) ((int)((x).size()))

enum State { BEFORE, IN_CELL, IN_DOUBLE_CELL, IN_QUOTE };

vector<string> parse(string s) {
	vector<string> tokens;

	string cur = "";
	int st = BEFORE;
	for (char c : s) {
		if (st == BEFORE) {
			if (c == '"') {
				st = IN_DOUBLE_CELL;
			} else if (c == ',') {
				tokens.push_back(cur);
			} else {
				st = IN_CELL;
				cur += c;
			}
			
		} else if (st == IN_CELL) {
			if (c == ',') {
				st = BEFORE;
				tokens.push_back(cur);
				cur = "";
			} else {
				cur += c;
			}

		} else if (st == IN_DOUBLE_CELL) {
			if (c == '"') {
				st = IN_QUOTE;
			} else {
				cur += c;
			}

		} else if (st == IN_QUOTE) {
			if (c == '"') {
				st = IN_DOUBLE_CELL;
				cur += c;
			} else {
				tokens.push_back(cur);
				cur = "";
				st = BEFORE;
			}
		}
	}

	if (Sz(cur))
		tokens.push_back(cur);

	return tokens;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	string row;
	vector<vector<string>> rows;
	vector<int> maxlen(1000, 0);
	int maxc = 0;
	while (getline(cin, row)) {
		rows.push_back(parse(row));
		vector<string> last = rows.back();
		for (int i = 0; i < Sz(last); ++i)
			maxlen[i] = max(maxlen[i], Sz(last[i]));
		maxc = max(maxc, Sz(last));
	}

	for (auto& i : rows)
		i.resize(maxc);

	for (auto& i : rows) {
		for (int j = 0; j < Sz(i); ++j) {
			if (j)
				cout << "|";
			i[j] += string(maxlen[j] - Sz(i[j]), ' ');
			cout << i[j];

		}
		cout << endl;
	}

	return 0;
}