#include <bits/stdc++.h>

using namespace std;

#define int long long

const int maxn = 2e5 + 10;
const int mod = ((int) 1e18 - 1) / 9;

void fail() {
    cout << 0 << '\n';
    exit(0);
}

struct Edge {
    int from;
    int to;
    int ind;
    string tp;
};

int unknown;
char used_edges[maxn];
char used[maxn];
int n, m;
vector<Edge> graph[maxn];
Edge parent_edge[maxn];
int answer = 1;

void f(int &cnt, int &mult, const string &tp) {
    if (tp == "?") --unknown;
    if (tp == "?") ++cnt;
    if (tp == "-") mult = -mult;
}

void recalc(int v, int root, Edge backedge) {
    //cerr << "recalc " << v << ' ' << root << endl;
    int cnt = 0;
    int mult = 1;
    f(cnt, mult, backedge.tp);
    used_edges[backedge.ind] = true;
    while (v != root) {
        f(cnt, mult, parent_edge[v].tp);
        if (used_edges[parent_edge[v].ind]) {
            //cerr << "fail1 " << v << ' ' << root << endl;
            fail();
        }
        used_edges[parent_edge[v].ind] = true;
        v = parent_edge[v].from;
    }
    if (mult == 1 && cnt == 0) {
        //cerr << "fail2 " << v << ' ' << root << endl;
        fail();
    }
    for (int i = 1; i < cnt; ++i) {
        answer *= 2;
        if (answer >= mod) answer -= mod;
    }
}

void dfs(int v, int p) {
    used[v] = true;
    for (auto e: graph[v]) {
        if (e.ind == p) continue;
        if (used[e.to] && !used_edges[e.ind]) {
            recalc(v, e.to, e);
        } else if (!used[e.to]) {
            parent_edge[e.to] = e;
            dfs(e.to, e.ind);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b; string tp;
        cin >> a >> b >> tp;
        --a; --b;
        if (tp == "?") ++unknown;
        graph[a].push_back(Edge{a, b, i, tp});
        graph[b].push_back(Edge{b, a, i, tp});
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, -1);
        }
    }

    for (int i = 0; i < unknown; ++i) {
        answer *= 2;
        if (answer >= mod) answer -= mod;
    }
    cout << answer;

}

