#include <bits/stdc++.h>

using namespace std;

const int tsize = 1 << 17;

struct Node {
    int sum;
    int assign;
    bool flag;
    int len;
};

Node tree[2 * tsize];

void init() {
    for (int i = tsize; i < 2 * tsize; ++i) {
        tree[i].len = 1;
    }
    for (int i = tsize - 1; i > 0; --i) {
        tree[i].len = tree[i * 2].len + tree[i * 2 + 1].len;
    }
}

void updateNode(int v, int x) {
    tree[v].flag = true;
    tree[v].assign = x;
    tree[v].sum = x * tree[v].len;
}

void push(int v) {
    if (v >= tsize || !tree[v].flag) return;
    updateNode(v * 2, tree[v].assign);
    updateNode(v * 2 + 1, tree[v].assign);
    tree[v].flag = false;
}

void update(int l, int r, int value, int v=1, int tl=0, int tr=tsize-1) {
    push(v);
    if (tr < l || r < tl) return;
    if (l <= tl && tr <= r) {
        updateNode(v, value);
        return;
    }
    int tm = (tl + tr) / 2;
    update(l, r, value, v * 2, tl, tm);
    update(l, r, value, v * 2 + 1, tm + 1, tr);
    tree[v].sum = tree[v * 2].sum + tree[v * 2 + 1].sum;
}

int get(int l, int r, int v=1, int tl=0, int tr=tsize-1) {
    push(v);
    if (tr < l || r < tl) return 0;
    if (l <= tl && tr <= r) {
        return tree[v].sum;
    }
    int tm = (tl + tr) / 2;
    int a = get(l, r, v * 2, tl, tm);
    int b = get(l, r, v * 2 + 1, tm + 1, tr);
    return a + b;
}

int find_another(int pos, int value) {
    int sumpref = pos ? get(0, pos - 1): 0;
    int ans = 0;
    int sum = 0;
    int v = 1;
    while (v < tsize) {
        push(v);
        if (ans + tree[v * 2].len - 1 < pos ||
        value * (ans + tree[v * 2].len - pos) == sum + tree[v * 2].sum - sumpref) {
            sum += tree[v * 2].sum;
            ans += tree[v * 2].len;
            v = v * 2 + 1;
        } else {
            v = v * 2;
        }
    }
    return ans;
}

void query_add(int p) {
    //cerr << "add " << p << endl;
    if (get(p, p) == 0) {
        update(p, p, 1);
        return;
    }
    int pos = find_another(p, 1);
    //cerr << ' ' << pos << endl;
    update(p, pos - 1, 0);
    update(pos, pos, 1);

}

void query_del(int p) {
    //cerr << "del " << p << endl;
     if (get(p, p) == 1) {
        update(p, p, 0);
        return;
    }
    int pos = find_another(p, 0);
    update(p, pos - 1, 1);
    update(pos, pos, 0);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    init();

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s; int p;
        cin >> s >> p;
        if (s == "add") query_add(p);
        else query_del(p);
        cout << tree[1].sum << '\n';
    }
}
