#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long double ftype;
typedef complex<ftype> point;
#define x real
#define y imag

ftype cross(point a, point b)
{
	return (conj(a) * b).y();
}

const double inf = 1e9, eps = 1e-15;
const ftype pi = acos(-1.);


bool check(vector<point> a, vector<point> b, point r)
{
    int n = a.size();
    for(auto &it: b)
        it *= r;
    auto cmp = [](point a, point b)
    {
        if(abs(norm(a) - norm(b)) > eps)
            return norm(a) < norm(b);
    	if(a.y() > 0 == b.y() >= 0)
        	return cross(a, b) < 0;
    	return a.y() < 0;
    };
    sort(begin(a), end(a), cmp);
    sort(begin(b), end(b), cmp);
    for(int i = 0; i < n; i++)
        if(norm(a[i] - b[i]) > eps)
            return 0;
    return 1;
}


signed main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<point> r[2];
    ld x, y;
    point mid[2] = {0};
    for(int z = 0; z <= 1; z++)
    for(int i = 0; i < n; i++)
    {
        cin >> x >> y;
        r[z].emplace_back(x, y);
        mid[z] += r[z][i];
    }
    mid[0] /= n;
    mid[1] /= n;
    for(int i = 0; i < n; i++)
    {
        r[0][i] -= mid[0];
        r[1][i] -= mid[1];
    }
    int ptr = 0;
    while(ptr < n && norm(r[0][ptr]) < eps)
        ptr++;
    if(ptr == n)
    {
        cout << 0 << endl;
        return 0;
    }
    ftype ans = 2 * pi;
    for(int i = 0; i < n; i++)
    {
        if(norm(r[1][i]) < eps)
            continue;
        if(abs(norm(r[0][ptr]) - norm(r[1][i])) > eps)
            continue;
        point rot = r[0][ptr] / r[1][i];
        if(check(r[0], r[1], rot))
            ans = min(ans, (ftype)abs(arg(complex<ld>(rot.x(), rot.y()))));
    }
assert(ans >= 0 && ans <= pi);
    cout << fixed << setprecision(10) << (ld)ans << endl;
}
