#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
#define mp make_pair

struct Node {
	int sum; //sum value in subtree
	int s; //set value or -1
	Node() {
		sum = 0;
		s = -1;
	}
};

const int N = 1e5 + 100;
Node t[N * 8];

void push(int v, int tl, int tr) {
	Node& n = t[v];
	int len = (tr - tl) + 1;
	if (n.s != -1) {
		t[v * 2].s = n.s;
		t[v * 2 + 1].s = n.s;
		if (n.s == 0) {
			n.sum = 0;
		}
		else {
			n.sum = len;
		}
		n.s = -1;
	}
}

void act(int v, int tl, int tr) {
	Node& n = t[v];
	int m = (tl + tr) / 2;
	push(v * 2, tl, m);
	push(v * 2 + 1, m + 1, tr);
	n.sum = t[v * 2].sum + t[v * 2 + 1].sum;
}

void segment_set(int v, int tl, int tr, int l, int r, int val) {
	if (l > r) return;
	push(v, tl, tr);
	act(v, tl, tr);
	if (l == tl && r == tr) {
		t[v].s = val;
		return;
	}
	int m = (tl + tr) / 2;
	segment_set(v * 2, tl, m, l, min(r, m), val);
	segment_set(v * 2 + 1, m + 1, tr, max(m + 1, l), r, val);
	push(v, tl, tr);
	act(v, tl, tr);
}

int get_sum(int v, int tl, int tr, int l, int r) {
	if (l > r) return 0;
	push(v, tl, tr);
	act(v, tl, tr);
	if (tl == l && tr == r) {
		return t[v].sum;
	}
	int m = (tl + tr) / 2;
	return get_sum(v * 2, tl, m, l, min(m, r)) +
		get_sum(v * 2 + 1, m + 1, tr, max(m + 1, l), r);
}

int cur = 0;
const int n = 1e5 + 200;

void add(int pos) {
	if (get_sum(1, 0, n - 1, pos, pos) == 0) {
		segment_set(1, 0, n - 1, pos, pos, 1);
		cur++;
	}
	else {
		int l = pos;
		int r = n;
		while (r - l > 1) {
			int m = (l + r) / 2;
			int len = m - pos + 1;
			if (get_sum(1, 0, n - 1, l, m) == len)
				l = m;
			else
				r = m;
		}
		//r - first zero char position
		cur -= r - pos;
		segment_set(1, 0, n - 1, r, r, 1);
		segment_set(1, 0, n - 1, pos, r - 1, 0);
		cur++;
	}
	cout << cur << "\n";
}

void sub(int pos) {
	if (get_sum(1, 0, n - 1, pos, pos) == 1) {
		segment_set(1, 0, n - 1, pos, pos, 0);
		cur--;
	}
	else {
		int l = pos;
		int r = n;
		while (r - l > 1) {
			int m = (l + r) / 2;
			int len = m - pos + 1;
			if (get_sum(1, 0, n - 1, l, m) == 0)
				l = m;
			else
				r = m;
		}
		//r - first zero char position
		cur += r - pos;
		segment_set(1, 0, n - 1, r, r, 0);
		segment_set(1, 0, n - 1, pos, r - 1, 1);
		cur--;
	}
	cout << cur << "\n";
}

void print() {
	for (int i = 0; i < 10; i++) {
		cout << get_sum(1, 0, n - 1, i, i);
	}
	cout << endl;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		string s;
		cin >> s;
		int pos;
		cin >> pos;
		if (s[0] == 'a')
			add(pos);
		else
			sub(pos);
		//print();
	}

	return 0;
}