#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;

bool check_square(int a, int b) {
	if (a == 0 || b == 0) return 0;
	return a == b;
}

int solve_slow(ll w, ll h) {
	int ans = 0;
	for (int i = 0; i <= w; i++) {
		for (int j = i; j <= w; j++) {
			int res = 0;
			int w1 = i;
			int w2 = j - i;
			int w3 = w - j;
			res = check_square(w1, h) + check_square(w2, h) + check_square(w3, h);
			ans = max(ans, res);
		}
	}
	swap(h, w);
	for (int i = 0; i <= w; i++) {
		for (int j = i; j <= w; j++) {
			int res = 0;
			int w1 = i;
			int w2 = j - i;
			int w3 = w - j;
			res = check_square(w1, h) + check_square(w2, h) + check_square(w3, h);
			ans = max(ans, res);
		}
	}
	for (int i = 0; i <= w; i++) {
		for (int j = 0; j <= h; j++) {
			int w1 = i;
			int w2 = w - i;
			int h1 = j;
			int h2 = h - j;
			int res = check_square(w1, h1) +
				check_square(w2, h1) + check_square(w1, h2) +
				check_square(w2, h2);
			ans = max(ans, res);
			/*if (ans == 2) {
				cout << i << " " << j;
				exit(0);
			}*/
		}
	}
	return ans;
}
int solve(ll w, ll h) {
	int ans = 0;
	//не проводим линий
	if (w == h) {
		ans = max(ans, 1);
	}
	if (w > 1 && w == h) {
		ans = max(ans, 2);
	}

	//проводим одну линию
	//обрезаем меньшую сторону, делаем один квадрат
	ans = max(ans, 1);
	//делаем два квадрата, должна быть одинаковая ширина и высота
	if ((check_square(w / 2, h) && check_square(w - w / 2, h)) ||
		(check_square(w, h / 2) && check_square(w, h - h / 2))) {
		ans = max(ans, 2);
	}


	//проводим ровно две линии

	//проводим по одной стороне - это должна быть большая сторона
	if (w < h) swap(w, h);
	if (w == 3 * h) {
		ans = max(ans, 3);
	}
	if (w >= h * 2) {
		ans = max(ans, 2);
	}

	//проводим по разным линиям

	//пытаемся получить два квадрата
	if (w % 2 == 0 || h % 2 == 0) {
		//рубим большую пополам, у меньшей отсекаем часть
		ans = max(ans, 2);
	}
	if (w % 2 == 0 && h % 2 == 0) {
		if (check_square(w / 2, h / 2)) {
			ans = max(ans, 4);
		}
	}
	return ans;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int ans = 0;
	ll w, h;

	/*for (int w = 1; w < 100; w++) {
		for (int h = 1; h < 100; h++) {
			if (solve_slow(w, h) != solve(w, h)) {
				cout << w << " " << h;
				return 0;
			}
		}
	}*/

	cin >> w >> h;
	cout << solve(w, h);

	return 0;
}