#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
#define mp make_pair
typedef vector<vector<int>> Mat;

Mat mul(Mat a, Mat b) {
	Mat res(a.size(), vector<int>(b[0].size()));
	for (int i = 0; i < a.size(); ++i) {
		for (int j = 0; j < b[0].size(); ++j) {
			int sum = 0;
			for (int k = 0; k < a[0].size(); ++k) {
				sum += a[i][k] * b[k][j];
			}
			res[i][j] = sum;
		}
	}
	return res;
}

int main() {	
	freopen("input.txt", "r", stdin);

	ll n, m, k;
	cin >> n >> m >> k;

	vector<int> p1(n);
	for (int i = 0; i < p1.size(); ++i) {
		p1[i] = i + 1;
	}
	vector<int> p2 = p1;
	vector<pair<int,int>> sws;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a;
		--b;
		sws.push_back(mp(a, b));
		swap(p2[a], p2[b]);
	}
	
	Mat mm(4, vector<int>(4));
	for (int i = 0; i < p2.size(); ++i) {
		mm[i][p2[i] - 1] = 1;
	}

	ll power = k / m;
	ll rest = k % m;
	
	Mat res(4, vector<int>(4));
	for (int i = 0; i < res.size(); ++i) {
		res[i][i] = 1;
	}
	while (power) {
		if (power) {
			res = mul(mm, res);
			--power;
		}
		else {
			power /= 2;
			mm = mul(mm, mm);
		}
	}

	Mat msper(4, vector<int>(1));
	for (int i = 0; i < 4; ++i) {
		msper[i][0] = i + 1;
	}
	Mat mfper = mul(res, msper);

	vector<int> fper(4);
	for (int i = 0; i < 4; ++i) {
		fper[i] = mfper[i][0];
	}

	for (int i = 0; i < rest; ++i) {
		swap(fper[sws[i].first], fper[sws[i].second]);
	}
	for (int i = 0; i < fper.size(); ++i) {
		cout << fper[i] << ' ';
	}

	return 0;
}