#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double ld;

const ll mod = (ll(1e18) - 1) / 9;

void mul(ll& a, ll b)
{
    a *= b;
    if (a >= mod) {
        a %= mod;
    }
}

struct edge
{
    int from, to;
    char c;
};

vector<vector<edge> > g;
vector<edge> edges;
vector<int> parent, size;
vector<int> sum;
vector<char> used;
vector<int> p;
bool ok = true;

int get(int v)
{
    if (parent[v] == v) {
        return v;
    }
    return parent[v] = get(parent[v]);
}

void unite(int a, int b)
{
    a = get(a);
    b = get(b);
    if (a == b) {
        return;
    }
    if (size[a] < size[b]) {
        swap(a, b);
    }
    parent[b] = a;
    size[a] += size[b];
}

void dfs(int v)
{
    used[v] = true;
    for (edge& e : g[v]) {
        if (!used[e.to]) {
            unite(v, e.to);
            p[e.to] = v;
            sum[e.to] = sum[v];
            if (e.c == '-') {
                sum[e.to] ^= 1;
            }
            dfs(e.to);
        }
    }
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");

    int n, m;
    cin >> n >> m;

    set<pii> s;

    g.resize(n);
    edges.resize(m);
    parent.resize(n);
    size.resize(n);
    for (int i = 0; i < n; ++i) {
        parent[i] = i;
        size[i] = 1;
    }

    sum.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v;
        char c;
        cin >> u >> v >> c;
        --u, --v;
        if (c != '?') {
            g[u].pb({u, v, c});
            g[v].pb({v, u, c});
        }
        edges[i] = {u, v, c};
        if (u > v) {
            swap(u, v);
        }
        assert(!s.count({u, v}));
        s.insert({u, v});
    }

    used.assign(n, false);
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            p[i] = i;
            dfs(i);
        }
    }

    for (int i = 0; i < m; ++i) {
        int u = edges[i].from, v = edges[i].to;
        if (u == p[v] || v == p[u]) {
            continue;
        }
        if (edges[i].c == '?') {
            continue;
        }
        int s = sum[u] ^ sum[v];
        if (edges[i].c == '-') {
            s ^= 1;
        }
        if (s == 0) {
            ok = false;
        }
    }

    if (!ok) {
        cout << "0\n";
        return 0;
    }

    ll ans = 1;

    for (int i = 0; i < m; ++i) {
        int u = edges[i].from, v = edges[i].to;
        if (edges[i].c != '?') {
            continue;
        }
        u = get(u), v = get(v);
        if (u != v) {
            mul(ans, 2);
            unite(u, v);
        }
    }

    cout << ans << "\n";

}
