#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double ld;

const ll mod = (ll(1e18) - 1) / 9;

void mul(ll& a, ll b)
{
    a *= b;
    if (a >= mod) {
        a %= mod;
    }
}

struct edge
{
    int from, to;
    char c;
    int id;
};

vector<vector<edge> > g;
vector<edge> edges;
vector<int> parent, size;
vector<int> sum;
vector<char> used;
vector<int> p;
bool ok = true;

int get(int v)
{
    if (parent[v] == v) {
        return v;
    }
    return parent[v] = get(parent[v]);
}

void unite(int a, int b)
{
    a = get(a);
    b = get(b);
    if (a == b) {
        return;
    }
    if (size[a] < size[b]) {
        swap(a, b);
    }
    parent[b] = a;
    size[a] += size[b];
}

void dfs(int v)
{
    used[v] = true;
    for (edge& e : g[v]) {
        if (e.c == '?') {
            continue;
        }
        if (!used[e.to]) {
            unite(v, e.to);
            p[e.to] = v;
            sum[e.to] = sum[v];
            if (e.c == '-') {
                sum[e.to] ^= 1;
            }
            dfs(e.to);
        }
    }
}

vector<int> tin, ret;
vector<int> cycleId;
vector<int> pCycle, eCycle;
int timer = 0;

void dfsCycle(int v, int par, int id)
{
    used[v] = true;
    tin[v] = ret[v] = timer++;
    pCycle[v] = par;
    eCycle[v] = id;
    for (edge& e : g[v]) {
        if (e.to == par) {
            if (e.id != id) {
                ret[v] = min(ret[v], ret[e.to]);
                if (cycleId[e.id] != -1) {
                    ok = false;
                    return;
                }
                cycleId[e.id] = 1;
                if (cycleId[id] != -1) {
                    ok = false;
                    return;
                }
                cycleId[id] = 1;
            }
        } else if (used[e.to]) {
            int curr = v;
            ret[v] = min(ret[v], tin[e.to]);
            if (cycleId[e.id] == -1) {
                cycleId[e.id] = 1;
                while (curr != e.to) {
                    int pr = pCycle[curr];
                    if (cycleId[eCycle[curr]] != -1) {
                        ok = false;
                        return;
                    }
                    cycleId[eCycle[curr]] = 1;
                    curr = pr;
                }
            }
        } else {
            dfsCycle(e.to, v, e.id);
            ret[v] = min(ret[v], ret[e.to]);
            if (tin[v] < ret[e.to]) {
                if (cycleId[e.id] != -1) {
                    ok = false;
                    return;
                }
                cycleId[e.id] = 1;
            }
        }
    }
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");

    int n, m;
    cin >> n >> m;

    tin.resize(n);
    ret.resize(n);
    pCycle.assign(n, -1);
    eCycle.assign(n, -1);

    //set<pii> s;

    map<pii, int> mapa1, mapa2;

    g.resize(n);
    edges.resize(m);
    parent.resize(n);
    size.resize(n);
    for (int i = 0; i < n; ++i) {
        parent[i] = i;
        size[i] = 1;
    }

    sum.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v;
        char c;
        cin >> u >> v >> c;
        --u, --v;
        g[u].pb({u, v, c, i});
        g[v].pb({v, u, c, i});
        edges[i] = {u, v, c, i};
        if (u > v) {
            swap(u, v);
        }
        if (c == '-') {
            ++mapa1[{u, v}];
        } else if (c == '+') {
            ++mapa2[{u, v}];
        }
    }

    for (auto it : mapa1) {
        if (it.second >= 2) {
            ok = false;
        }
    }
    for (auto it : mapa2) {
        if (it.second >= 2) {
            ok = false;
        }
    }
    if (!ok) {
        cout << "0\n";
        return 0;
    }

    used.assign(n, false);
    cycleId.assign(m, -1);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfsCycle(i, -1, -1);
        }
    }

    if (!ok) {
        cout << "0\n";
        return 0;
    }

    used.assign(n, false);
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            p[i] = i;
            dfs(i);
        }
    }

    for (int i = 0; i < m; ++i) {
        int u = edges[i].from, v = edges[i].to;
        if (u == p[v] || v == p[u]) {
            continue;
        }
        if (edges[i].c == '?') {
            continue;
        }
        int s = sum[u] ^ sum[v];
        if (edges[i].c == '-') {
            s ^= 1;
        }
        if (s == 0) {
            ok = false;
        }
    }

    if (!ok) {
        cout << "0\n";
        return 0;
    }

    ll ans = 1;

    for (int i = 0; i < m; ++i) {
        int u = edges[i].from, v = edges[i].to;
        if (edges[i].c != '?') {
            continue;
        }
        u = get(u), v = get(v);
        if (u != v) {
            mul(ans, 2);
            unite(u, v);
        }
    }

    cout << ans << "\n";

}
