#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double ld;

const int nmax = 200500;

struct node
{
    int promise;
    int sum;
    node() : promise(-1), sum(0) {}
};

node t[4 * nmax];
int TL[4 * nmax], TR[4 * nmax];

void build(int v, int tl, int tr)
{
    TL[v] = tl;
    TR[v] = tr;
    if (tl == tr) {
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
}

void push(int v)
{
    if (t[v].promise == -1) {
        return;
    }
    int tl = TL[v], tr = TR[v];
    int tm = (tl + tr) >> 1;
    t[v * 2].promise = t[v].promise;
    t[v * 2].sum = t[v].promise * (tm - tl + 1);
    t[v * 2 + 1].promise = t[v].promise;
    t[v * 2 + 1].sum = t[v].promise * (tr - tm);
    t[v].promise = -1;
}

void get(int v, int tl, int tr, int l, int r, vector<int>& ans)
{
    push(v);
    if (tl == l && tr == r) {
        ans.pb(v);
        return;
    }
    int tm = (tl + tr) >> 1;
    if (l <= tm) {
        get(v * 2, tl, tm, l, min(r, tm), ans);
    }
    if (r > tm) {
        get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, ans);
    }
}

int lastZero(int v, int tl, int tr)
{
    if (tl == tr) {
        assert(t[v].sum == 0);
        return tl;
    }
    push(v);
    int tm = (tl + tr) >> 1;
    if (t[v * 2 + 1].sum != tr - tm) {
        return lastZero(v * 2 + 1, tm + 1, tr);
    } else {
        return lastZero(v * 2, tl, tm);
    }
}

int lastOne(int v, int tl, int tr)
{
    if (tl == tr) {
        assert(t[v].sum == 1);
        return tl;
    }
    push(v);
    int tm = (tl + tr) >> 1;
    if (t[v * 2 + 1].sum) {
        return lastOne(v * 2 + 1, tm + 1, tr);
    } else {
        return lastOne(v * 2, tl, tm);
    }
}

void update(int v, int tl, int tr, int l, int r, int val)
{
    if (tl == l && tr == r) {
        t[v].sum = (tr - tl + 1) * val;
        t[v].promise = val;
        return;
    }
    push(v);
    int tm = (tl + tr) >> 1;
    if (l <= tm) {
        update(v * 2, tl, tm, l, min(r, tm), val);
    }
    if (r > tm) {
        update(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, val);
    }
    t[v].sum = t[v * 2].sum + t[v * 2 + 1].sum;
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");

    int q;
    cin >> q;

    build(1, 0, nmax - 1);

    while (q--) {
        string type;
        cin >> type;
        int pos;
        cin >> pos;
        pos = nmax - 1 - pos;
        if (type == "add") {
            vector<int> v;
            get(1, 0, nmax - 1, 0, pos, v);
            int vert;
            for (int i = sz(v) - 1; i >= 0; --i) {
                int x = v[i];
                if (t[x].sum != TR[x] - TL[x] + 1) {
                    vert = x;
                    break;
                }
            }
            int z = lastZero(vert, TL[vert], TR[vert]);
            update(1, 0, nmax - 1, z, z, 1);
            if (z < pos) {
                update(1, 0, nmax - 1, z + 1, pos, 0);
            }
        } else {
            vector<int> v;
            get(1, 0, nmax - 1, 0, pos, v);
            int vert;
            for (int i = sz(v) - 1; i >= 0; --i) {
                int x = v[i];
                if (t[x].sum) {
                    vert = x;
                    break;
                }
            }
            int z = lastOne(vert, TL[vert], TR[vert]);
            update(1, 0, nmax - 1, z, z, 0);
            if (z < pos) {
                update(1, 0, nmax - 1, z + 1, pos, 1);
            }
        }

        cout << t[1].sum << "\n";
    }

}
