#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double ld;

const ld eps = 1e-6;
const ld pi = 4 * atan(1.0);

bool lt(ld a, ld b)
{
    return b - a > eps;
}

bool eq(ld a, ld b)
{
    return abs(a - b) <= eps;
}

bool leq(ld a, ld b)
{
    return lt(a, b) || eq(a, b);
}

bool gt(ld a, ld b)
{
    return a - b > eps;
}

bool geq(ld a, ld b)
{
    return gt(a, b) || eq(a, b);
}

struct pt
{
    ld x, y;
    pt() {}
    pt(ld x, ld y) : x(x), y(y) {}
    pt operator-(const pt& other) const
    {
        return {x - other.x, y - other.y};
    }
    pt operator+(const pt& other) const
    {
        return {x + other.x, y + other.y};
    }
    pt operator*(ld k) const
    {
        return {x * k, y * k};
    }
    bool operator<(const pt& other) const
    {
        if (!eq(x, other.x)) {
            return lt(x, other.x);
        }
        return lt(y, other.y);
    }
    bool operator==(const pt& other) const
    {
        return eq(x, other.x) && eq(y, other.y);
    }
};

ld cross(const pt& p, const pt& q)
{
    return p.x * q.y - p.y * q.x;
}

ld dot(const pt& p, const pt& q)
{
    return p.x * q.x + p.y * q.y;
}

ld dist(const pt& p, const pt& q)
{
    return sqrt((p.x - q.x) * (p.x - q.x) + (p.y - q.y) * (p.y - q.y));
}

pt rot(const pt& p, ld s, ld c)
{
    return {p.x * c - p.y * s, p.x * s + p.y * c};
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");
    //ofstream fout("output.txt");

    int n;
    cin >> n;

    vector<pt> a(n), b(n);
    pt ca = {0, 0}, cb = {0, 0};
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        ca = ca + a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> b[i].x >> b[i].y;
        cb = cb + b[i];
    }

    ca = ca * (ld(1) / n);
    cb = cb * (ld(1) / n);

    for (int i = 0; i < n; ++i) {
        a[i] = a[i] - ca;
        b[i] = b[i] - cb;
    }

    pt origin = {0, 0};

    ld ans = 2 * pi;

    if (n == 1) {
        cout << "0\n";
        return 0;
    }

    int id = 0;
    for (int i = 0; i < n; ++i) {
        if (!eq(a[i].x, 0) || !eq(a[i].y, 0)) {
            id = i;
            break;
        }
    }

    vector<pt> y = b;
    sort(all(y));

    for (int j = 0; j < n; ++j) {
        if (eq(dist(origin, a[id]), dist(origin, b[j]))) {
            ld alpha = dot(a[id], b[j]);
            alpha /= dist(origin, a[id]);
            alpha /= dist(origin, b[j]);
            if (alpha < -1) {
                alpha = -1;
            }
            if (alpha > 1) {
                alpha = 1;
            }
            ld c = alpha;
            alpha = acos(alpha);
            if (lt(cross(a[id], b[j]), 0)) {
                alpha = -alpha;
            }
            ld s = sin(alpha);
            vector<pt> x;
            for (int i = 0; i < n; ++i) {
                x.pb(rot(a[i], s, c));
            }
            sort(all(x));
            sort(all(y));
            if (x == y) {
                ans = min(ans, abs(alpha));
            }
        }
    }

    cout << fixed;
    cout.precision(12);
    cout << ans << "\n";

}
